diff --git a/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c b/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
index 587351d126..85eee41ada 100644
--- a/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
+++ b/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
@@ -1014,41 +934,41 @@ static int r_stem_nominal_verb_suffixes(struct SN_env * z) {
         goto lab0;
     lab1:
         z->c = z->l - m1;
-        {   int ret = r_mark_cAsInA(z);
-            if (ret == 0) goto lab6; /* call mark_cAsInA, line 316 */
+        {   int ret = r_mark_cAsInA(z); /* call mark_cAsInA, line 314 */
+            if (ret == 0) goto lab6;
             if (ret < 0) return ret;
         }
-        {   int m3 = z->l - z->c; (void)m3; /* or, line 316 */
-            {   int ret = r_mark_sUnUz(z);
-                if (ret == 0) goto lab8; /* call mark_sUnUz, line 316 */
+        {   int m3 = z->l - z->c; (void)m3; /* or, line 314 */
+            {   int ret = r_mark_sUnUz(z); /* call mark_sUnUz, line 314 */
+                if (ret == 0) goto lab8;
                 if (ret < 0) return ret;
             }
             goto lab7;
         lab8:
             z->c = z->l - m3;
-            {   int ret = r_mark_lAr(z);
-                if (ret == 0) goto lab9; /* call mark_lAr, line 316 */
+            {   int ret = r_mark_lAr(z); /* call mark_lAr, line 314 */
+                if (ret == 0) goto lab9;
                 if (ret < 0) return ret;
             }
             goto lab7;
         lab9:
             z->c = z->l - m3;
-            {   int ret = r_mark_yUm(z);
-                if (ret == 0) goto lab10; /* call mark_yUm, line 316 */
+            {   int ret = r_mark_yUm(z); /* call mark_yUm, line 314 */
+                if (ret == 0) goto lab10;
                 if (ret < 0) return ret;
             }
             goto lab7;
         lab10:
             z->c = z->l - m3;
-            {   int ret = r_mark_sUn(z);
-                if (ret == 0) goto lab11; /* call mark_sUn, line 316 */
+            {   int ret = r_mark_sUn(z); /* call mark_sUn, line 314 */
+                if (ret == 0) goto lab11;
                 if (ret < 0) return ret;
             }
             goto lab7;
         lab11:
             z->c = z->l - m3;
-            {   int ret = r_mark_yUz(z);
-                if (ret == 0) goto lab12; /* call mark_yUz, line 316 */
+            {   int ret = r_mark_yUz(z); /* call mark_yUz, line 314 */
+                if (ret == 0) goto lab12;
                 if (ret < 0) return ret;
             }
             goto lab7;
@@ -1056,47 +976,47 @@ static int r_stem_nominal_verb_suffixes(struct SN_env * z) {
             z->c = z->l - m3;
         }
     lab7:
-        {   int ret = r_mark_ymUs_(z);
-            if (ret == 0) goto lab6; /* call mark_ymUs_, line 316 */
+        {   int ret = r_mark_ymUs_(z); /* call mark_ymUs_, line 314 */
+            if (ret == 0) goto lab6;
             if (ret < 0) return ret;
         }
         goto lab0;
     lab6:
         z->c = z->l - m1;
-        {   int ret = r_mark_lAr(z);
-            if (ret == 0) goto lab13; /* call mark_lAr, line 319 */
+        {   int ret = r_mark_lAr(z); /* call mark_lAr, line 317 */
+            if (ret == 0) goto lab13;
             if (ret < 0) return ret;
         }
-        z->bra = z->c; /* ], line 319 */
-        {   int ret = slice_del(z); /* delete, line 319 */
+        z->bra = z->c; /* ], line 317 */
+        {   int ret = slice_del(z); /* delete, line 317 */
             if (ret < 0) return ret;
         }
-        {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 319 */
-            z->ket = z->c; /* [, line 319 */
-            {   int m4 = z->l - z->c; (void)m4; /* or, line 319 */
-                {   int ret = r_mark_DUr(z);
-                    if (ret == 0) goto lab16; /* call mark_DUr, line 319 */
+        {   int m4 = z->l - z->c; (void)m4; /* try, line 317 */
+            z->ket = z->c; /* [, line 317 */
+            {   int m5 = z->l - z->c; (void)m5; /* or, line 317 */
+                {   int ret = r_mark_DUr(z); /* call mark_DUr, line 317 */
+                    if (ret == 0) goto lab16;
                     if (ret < 0) return ret;
                 }
                 goto lab15;
             lab16:
-                z->c = z->l - m4;
-                {   int ret = r_mark_yDU(z);
-                    if (ret == 0) goto lab17; /* call mark_yDU, line 319 */
+                z->c = z->l - m5;
+                {   int ret = r_mark_yDU(z); /* call mark_yDU, line 317 */
+                    if (ret == 0) goto lab17;
                     if (ret < 0) return ret;
                 }
                 goto lab15;
             lab17:
-                z->c = z->l - m4;
-                {   int ret = r_mark_ysA(z);
-                    if (ret == 0) goto lab18; /* call mark_ysA, line 319 */
+                z->c = z->l - m5;
+                {   int ret = r_mark_ysA(z); /* call mark_ysA, line 317 */
+                    if (ret == 0) goto lab18;
                     if (ret < 0) return ret;
                 }
                 goto lab15;
             lab18:
-                z->c = z->l - m4;
-                {   int ret = r_mark_ymUs_(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab14; } /* call mark_ymUs_, line 319 */
+                z->c = z->l - m5;
+                {   int ret = r_mark_ymUs_(z); /* call mark_ymUs_, line 317 */
+                    if (ret == 0) { z->c = z->l - m4; goto lab14; }
                     if (ret < 0) return ret;
                 }
             }
@@ -1104,24 +1024,24 @@ static int r_stem_nominal_verb_suffixes(struct SN_env * z) {
         lab14:
             ;
         }
-        z->B[0] = 0; /* unset continue_stemming_noun_suffixes, line 320 */
+        z->B[0] = 0; /* unset continue_stemming_noun_suffixes, line 318 */
         goto lab0;
     lab13:
         z->c = z->l - m1;
-        {   int ret = r_mark_nUz(z);
-            if (ret == 0) goto lab19; /* call mark_nUz, line 323 */
+        {   int ret = r_mark_nUz(z); /* call mark_nUz, line 321 */
+            if (ret == 0) goto lab19;
             if (ret < 0) return ret;
         }
-        {   int m5 = z->l - z->c; (void)m5; /* or, line 323 */
-            {   int ret = r_mark_yDU(z);
-                if (ret == 0) goto lab21; /* call mark_yDU, line 323 */
+        {   int m6 = z->l - z->c; (void)m6; /* or, line 321 */
+            {   int ret = r_mark_yDU(z); /* call mark_yDU, line 321 */
+                if (ret == 0) goto lab21;
                 if (ret < 0) return ret;
             }
             goto lab20;
         lab21:
-            z->c = z->l - m5;
-            {   int ret = r_mark_ysA(z);
-                if (ret == 0) goto lab19; /* call mark_ysA, line 323 */
+            z->c = z->l - m6;
+            {   int ret = r_mark_ysA(z); /* call mark_ysA, line 321 */
+                if (ret == 0) goto lab19;
                 if (ret < 0) return ret;
             }
         }
@@ -1129,100 +1049,99 @@ static int r_stem_nominal_verb_suffixes(struct SN_env * z) {
         goto lab0;
     lab19:
         z->c = z->l - m1;
-        {   int m6 = z->l - z->c; (void)m6; /* or, line 325 */
-            {   int ret = r_mark_sUnUz(z);
-                if (ret == 0) goto lab24; /* call mark_sUnUz, line 325 */
+        {   int m7 = z->l - z->c; (void)m7; /* or, line 323 */
+            {   int ret = r_mark_sUnUz(z); /* call mark_sUnUz, line 323 */
+                if (ret == 0) goto lab24;
                 if (ret < 0) return ret;
             }
             goto lab23;
         lab24:
-            z->c = z->l - m6;
-            {   int ret = r_mark_yUz(z);
-                if (ret == 0) goto lab25; /* call mark_yUz, line 325 */
+            z->c = z->l - m7;
+            {   int ret = r_mark_yUz(z); /* call mark_yUz, line 323 */
+                if (ret == 0) goto lab25;
                 if (ret < 0) return ret;
             }
             goto lab23;
         lab25:
-            z->c = z->l - m6;
-            {   int ret = r_mark_sUn(z);
-                if (ret == 0) goto lab26; /* call mark_sUn, line 325 */
+            z->c = z->l - m7;
+            {   int ret = r_mark_sUn(z); /* call mark_sUn, line 323 */
+                if (ret == 0) goto lab26;
                 if (ret < 0) return ret;
             }
             goto lab23;
         lab26:
-            z->c = z->l - m6;
-            {   int ret = r_mark_yUm(z);
-                if (ret == 0) goto lab22; /* call mark_yUm, line 325 */
+            z->c = z->l - m7;
+            {   int ret = r_mark_yUm(z); /* call mark_yUm, line 323 */
+                if (ret == 0) goto lab22;
                 if (ret < 0) return ret;
             }
         }
     lab23:
+        z->bra = z->c; /* ], line 323 */
+        {   int ret = slice_del(z); /* delete, line 323 */
+            if (ret < 0) return ret;
+        }
+        {   int m8 = z->l - z->c; (void)m8; /* try, line 323 */
+            z->ket = z->c; /* [, line 323 */
+            {   int ret = r_mark_ymUs_(z); /* call mark_ymUs_, line 323 */
+                if (ret == 0) { z->c = z->l - m8; goto lab27; }
+                if (ret < 0) return ret;
+            }
+        lab27:
+            ;
+        }
+        goto lab0;
+    lab22:
+        z->c = z->l - m1;
+        {   int ret = r_mark_DUr(z); /* call mark_DUr, line 325 */
+            if (ret <= 0) return ret;
+        }
         z->bra = z->c; /* ], line 325 */
         {   int ret = slice_del(z); /* delete, line 325 */
             if (ret < 0) return ret;
         }
-        {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 325 */
+        {   int m9 = z->l - z->c; (void)m9; /* try, line 325 */
             z->ket = z->c; /* [, line 325 */
-            {   int ret = r_mark_ymUs_(z);
-                if (ret == 0) { z->c = z->l - m_keep; goto lab27; } /* call mark_ymUs_, line 325 */
-                if (ret < 0) return ret;
-            }
-        lab27:
-            ;
-        }
-        goto lab0;
-    lab22:
-        z->c = z->l - m1;
-        {   int ret = r_mark_DUr(z);
-            if (ret == 0) return 0; /* call mark_DUr, line 327 */
-            if (ret < 0) return ret;
-        }
-        z->bra = z->c; /* ], line 327 */
-        {   int ret = slice_del(z); /* delete, line 327 */
-            if (ret < 0) return ret;
-        }
-        {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 327 */
-            z->ket = z->c; /* [, line 327 */
-            {   int m7 = z->l - z->c; (void)m7; /* or, line 327 */
-                {   int ret = r_mark_sUnUz(z);
-                    if (ret == 0) goto lab30; /* call mark_sUnUz, line 327 */
+            {   int m10 = z->l - z->c; (void)m10; /* or, line 325 */
+                {   int ret = r_mark_sUnUz(z); /* call mark_sUnUz, line 325 */
+                    if (ret == 0) goto lab30;
                     if (ret < 0) return ret;
                 }
                 goto lab29;
             lab30:
-                z->c = z->l - m7;
-                {   int ret = r_mark_lAr(z);
-                    if (ret == 0) goto lab31; /* call mark_lAr, line 327 */
+                z->c = z->l - m10;
+                {   int ret = r_mark_lAr(z); /* call mark_lAr, line 325 */
+                    if (ret == 0) goto lab31;
                     if (ret < 0) return ret;
                 }
                 goto lab29;
             lab31:
-                z->c = z->l - m7;
-                {   int ret = r_mark_yUm(z);
-                    if (ret == 0) goto lab32; /* call mark_yUm, line 327 */
+                z->c = z->l - m10;
+                {   int ret = r_mark_yUm(z); /* call mark_yUm, line 325 */
+                    if (ret == 0) goto lab32;
                     if (ret < 0) return ret;
                 }
                 goto lab29;
             lab32:
-                z->c = z->l - m7;
-                {   int ret = r_mark_sUn(z);
-                    if (ret == 0) goto lab33; /* call mark_sUn, line 327 */
+                z->c = z->l - m10;
+                {   int ret = r_mark_sUn(z); /* call mark_sUn, line 325 */
+                    if (ret == 0) goto lab33;
                     if (ret < 0) return ret;
                 }
                 goto lab29;
             lab33:
-                z->c = z->l - m7;
-                {   int ret = r_mark_yUz(z);
-                    if (ret == 0) goto lab34; /* call mark_yUz, line 327 */
+                z->c = z->l - m10;
+                {   int ret = r_mark_yUz(z); /* call mark_yUz, line 325 */
+                    if (ret == 0) goto lab34;
                     if (ret < 0) return ret;
                 }
                 goto lab29;
             lab34:
-                z->c = z->l - m7;
+                z->c = z->l - m10;
             }
         lab29:
-            {   int ret = r_mark_ymUs_(z);
-                if (ret == 0) { z->c = z->l - m_keep; goto lab28; } /* call mark_ymUs_, line 327 */
+            {   int ret = r_mark_ymUs_(z); /* call mark_ymUs_, line 325 */
+                if (ret == 0) { z->c = z->l - m9; goto lab28; }
                 if (ret < 0) return ret;
             }
         lab28:
@@ -1230,42 +1149,41 @@ static int r_stem_nominal_verb_suffixes(struct SN_env * z) {
         }
     }
 lab0:
-    z->bra = z->c; /* ], line 328 */
-    {   int ret = slice_del(z); /* delete, line 328 */
+    z->bra = z->c; /* ], line 326 */
+    {   int ret = slice_del(z); /* delete, line 326 */
         if (ret < 0) return ret;
     }
     return 1;
 }
 
-static int r_stem_suffix_chain_before_ki(struct SN_env * z) {
-    z->ket = z->c; /* [, line 333 */
-    {   int ret = r_mark_ki(z);
-        if (ret == 0) return 0; /* call mark_ki, line 334 */
-        if (ret < 0) return ret;
+static int r_stem_suffix_chain_before_ki(struct SN_env * z) { /* backwardmode */
+    z->ket = z->c; /* [, line 331 */
+    {   int ret = r_mark_ki(z); /* call mark_ki, line 332 */
+        if (ret <= 0) return ret;
     }
-    {   int m1 = z->l - z->c; (void)m1; /* or, line 342 */
-        {   int ret = r_mark_DA(z);
-            if (ret == 0) goto lab1; /* call mark_DA, line 336 */
+    {   int m1 = z->l - z->c; (void)m1; /* or, line 340 */
+        {   int ret = r_mark_DA(z); /* call mark_DA, line 334 */
+            if (ret == 0) goto lab1;
             if (ret < 0) return ret;
         }
-        z->bra = z->c; /* ], line 336 */
-        {   int ret = slice_del(z); /* delete, line 336 */
+        z->bra = z->c; /* ], line 334 */
+        {   int ret = slice_del(z); /* delete, line 334 */
             if (ret < 0) return ret;
         }
-        {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 336 */
-            z->ket = z->c; /* [, line 336 */
-            {   int m2 = z->l - z->c; (void)m2; /* or, line 338 */
-                {   int ret = r_mark_lAr(z);
-                    if (ret == 0) goto lab4; /* call mark_lAr, line 337 */
+        {   int m2 = z->l - z->c; (void)m2; /* try, line 334 */
+            z->ket = z->c; /* [, line 334 */
+            {   int m3 = z->l - z->c; (void)m3; /* or, line 336 */
+                {   int ret = r_mark_lAr(z); /* call mark_lAr, line 335 */
+                    if (ret == 0) goto lab4;
                     if (ret < 0) return ret;
                 }
-                z->bra = z->c; /* ], line 337 */
-                {   int ret = slice_del(z); /* delete, line 337 */
+                z->bra = z->c; /* ], line 335 */
+                {   int ret = slice_del(z); /* delete, line 335 */
                     if (ret < 0) return ret;
                 }
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 337 */
-                    {   int ret = r_stem_suffix_chain_before_ki(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab5; } /* call stem_suffix_chain_before_ki, line 337 */
+                {   int m4 = z->l - z->c; (void)m4; /* try, line 335 */
+                    {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 335 */
+                        if (ret == 0) { z->c = z->l - m4; goto lab5; }
                         if (ret < 0) return ret;
                     }
                 lab5:
@@ -1273,27 +1191,27 @@ static int r_stem_suffix_chain_before_ki(struct SN_env * z) {
                 }
                 goto lab3;
             lab4:
-                z->c = z->l - m2;
-                {   int ret = r_mark_possessives(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab2; } /* call mark_possessives, line 339 */
+                z->c = z->l - m3;
+                {   int ret = r_mark_possessives(z); /* call mark_possessives, line 337 */
+                    if (ret == 0) { z->c = z->l - m2; goto lab2; }
                     if (ret < 0) return ret;
                 }
-                z->bra = z->c; /* ], line 339 */
-                {   int ret = slice_del(z); /* delete, line 339 */
+                z->bra = z->c; /* ], line 337 */
+                {   int ret = slice_del(z); /* delete, line 337 */
                     if (ret < 0) return ret;
                 }
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 339 */
-                    z->ket = z->c; /* [, line 339 */
-                    {   int ret = r_mark_lAr(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab6; } /* call mark_lAr, line 339 */
+                {   int m5 = z->l - z->c; (void)m5; /* try, line 337 */
+                    z->ket = z->c; /* [, line 337 */
+                    {   int ret = r_mark_lAr(z); /* call mark_lAr, line 337 */
+                        if (ret == 0) { z->c = z->l - m5; goto lab6; }
                         if (ret < 0) return ret;
                     }
-                    z->bra = z->c; /* ], line 339 */
-                    {   int ret = slice_del(z); /* delete, line 339 */
+                    z->bra = z->c; /* ], line 337 */
+                    {   int ret = slice_del(z); /* delete, line 337 */
                         if (ret < 0) return ret;
                     }
-                    {   int ret = r_stem_suffix_chain_before_ki(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab6; } /* call stem_suffix_chain_before_ki, line 339 */
+                    {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 337 */
+                        if (ret == 0) { z->c = z->l - m5; goto lab6; }
                         if (ret < 0) return ret;
                     }
                 lab6:
@@ -1307,59 +1225,59 @@ static int r_stem_suffix_chain_before_ki(struct SN_env * z) {
         goto lab0;
     lab1:
         z->c = z->l - m1;
-        {   int ret = r_mark_nUn(z);
-            if (ret == 0) goto lab7; /* call mark_nUn, line 343 */
+        {   int ret = r_mark_nUn(z); /* call mark_nUn, line 341 */
+            if (ret == 0) goto lab7;
             if (ret < 0) return ret;
         }
-        z->bra = z->c; /* ], line 343 */
-        {   int ret = slice_del(z); /* delete, line 343 */
+        z->bra = z->c; /* ], line 341 */
+        {   int ret = slice_del(z); /* delete, line 341 */
             if (ret < 0) return ret;
         }
-        {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 343 */
-            z->ket = z->c; /* [, line 343 */
-            {   int m3 = z->l - z->c; (void)m3; /* or, line 345 */
-                {   int ret = r_mark_lArI(z);
-                    if (ret == 0) goto lab10; /* call mark_lArI, line 344 */
+        {   int m6 = z->l - z->c; (void)m6; /* try, line 341 */
+            z->ket = z->c; /* [, line 341 */
+            {   int m7 = z->l - z->c; (void)m7; /* or, line 343 */
+                {   int ret = r_mark_lArI(z); /* call mark_lArI, line 342 */
+                    if (ret == 0) goto lab10;
                     if (ret < 0) return ret;
                 }
-                z->bra = z->c; /* ], line 344 */
-                {   int ret = slice_del(z); /* delete, line 344 */
+                z->bra = z->c; /* ], line 342 */
+                {   int ret = slice_del(z); /* delete, line 342 */
                     if (ret < 0) return ret;
                 }
                 goto lab9;
             lab10:
-                z->c = z->l - m3;
-                z->ket = z->c; /* [, line 346 */
-                {   int m4 = z->l - z->c; (void)m4; /* or, line 346 */
-                    {   int ret = r_mark_possessives(z);
-                        if (ret == 0) goto lab13; /* call mark_possessives, line 346 */
+                z->c = z->l - m7;
+                z->ket = z->c; /* [, line 344 */
+                {   int m8 = z->l - z->c; (void)m8; /* or, line 344 */
+                    {   int ret = r_mark_possessives(z); /* call mark_possessives, line 344 */
+                        if (ret == 0) goto lab13;
                         if (ret < 0) return ret;
                     }
                     goto lab12;
                 lab13:
-                    z->c = z->l - m4;
-                    {   int ret = r_mark_sU(z);
-                        if (ret == 0) goto lab11; /* call mark_sU, line 346 */
+                    z->c = z->l - m8;
+                    {   int ret = r_mark_sU(z); /* call mark_sU, line 344 */
+                        if (ret == 0) goto lab11;
                         if (ret < 0) return ret;
                     }
                 }
             lab12:
-                z->bra = z->c; /* ], line 346 */
-                {   int ret = slice_del(z); /* delete, line 346 */
+                z->bra = z->c; /* ], line 344 */
+                {   int ret = slice_del(z); /* delete, line 344 */
                     if (ret < 0) return ret;
                 }
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 346 */
-                    z->ket = z->c; /* [, line 346 */
-                    {   int ret = r_mark_lAr(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab14; } /* call mark_lAr, line 346 */
+                {   int m9 = z->l - z->c; (void)m9; /* try, line 344 */
+                    z->ket = z->c; /* [, line 344 */
+                    {   int ret = r_mark_lAr(z); /* call mark_lAr, line 344 */
+                        if (ret == 0) { z->c = z->l - m9; goto lab14; }
                         if (ret < 0) return ret;
                     }
-                    z->bra = z->c; /* ], line 346 */
-                    {   int ret = slice_del(z); /* delete, line 346 */
+                    z->bra = z->c; /* ], line 344 */
+                    {   int ret = slice_del(z); /* delete, line 344 */
                         if (ret < 0) return ret;
                     }
-                    {   int ret = r_stem_suffix_chain_before_ki(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab14; } /* call stem_suffix_chain_before_ki, line 346 */
+                    {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 344 */
+                        if (ret == 0) { z->c = z->l - m9; goto lab14; }
                         if (ret < 0) return ret;
                     }
                 lab14:
@@ -1367,9 +1285,9 @@ static int r_stem_suffix_chain_before_ki(struct SN_env * z) {
                 }
                 goto lab9;
             lab11:
-                z->c = z->l - m3;
-                {   int ret = r_stem_suffix_chain_before_ki(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab8; } /* call stem_suffix_chain_before_ki, line 348 */
+                z->c = z->l - m7;
+                {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 346 */
+                    if (ret == 0) { z->c = z->l - m6; goto lab8; }
                     if (ret < 0) return ret;
                 }
             }
@@ -1380,42 +1298,41 @@ static int r_stem_suffix_chain_before_ki(struct SN_env * z) {
         goto lab0;
     lab7:
         z->c = z->l - m1;
-        {   int ret = r_mark_ndA(z);
-            if (ret == 0) return 0; /* call mark_ndA, line 351 */
-            if (ret < 0) return ret;
+        {   int ret = r_mark_ndA(z); /* call mark_ndA, line 349 */
+            if (ret <= 0) return ret;
         }
-        {   int m5 = z->l - z->c; (void)m5; /* or, line 353 */
-            {   int ret = r_mark_lArI(z);
-                if (ret == 0) goto lab16; /* call mark_lArI, line 352 */
+        {   int m10 = z->l - z->c; (void)m10; /* or, line 351 */
+            {   int ret = r_mark_lArI(z); /* call mark_lArI, line 350 */
+                if (ret == 0) goto lab16;
+                if (ret < 0) return ret;
+            }
+            z->bra = z->c; /* ], line 350 */
+            {   int ret = slice_del(z); /* delete, line 350 */
+                if (ret < 0) return ret;
+            }
+            goto lab15;
+        lab16:
+            z->c = z->l - m10;
+            {   int ret = r_mark_sU(z); /* call mark_sU, line 352 */
+                if (ret == 0) goto lab17;
                 if (ret < 0) return ret;
             }
             z->bra = z->c; /* ], line 352 */
             {   int ret = slice_del(z); /* delete, line 352 */
                 if (ret < 0) return ret;
             }
-            goto lab15;
-        lab16:
-            z->c = z->l - m5;
-            {   int ret = r_mark_sU(z);
-                if (ret == 0) goto lab17; /* call mark_sU, line 354 */
-                if (ret < 0) return ret;
-            }
-            z->bra = z->c; /* ], line 354 */
-            {   int ret = slice_del(z); /* delete, line 354 */
-                if (ret < 0) return ret;
-            }
-            {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 354 */
-                z->ket = z->c; /* [, line 354 */
-                {   int ret = r_mark_lAr(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab18; } /* call mark_lAr, line 354 */
+            {   int m11 = z->l - z->c; (void)m11; /* try, line 352 */
+                z->ket = z->c; /* [, line 352 */
+                {   int ret = r_mark_lAr(z); /* call mark_lAr, line 352 */
+                    if (ret == 0) { z->c = z->l - m11; goto lab18; }
                     if (ret < 0) return ret;
                 }
-                z->bra = z->c; /* ], line 354 */
-                {   int ret = slice_del(z); /* delete, line 354 */
+                z->bra = z->c; /* ], line 352 */
+                {   int ret = slice_del(z); /* delete, line 352 */
                     if (ret < 0) return ret;
                 }
-                {   int ret = r_stem_suffix_chain_before_ki(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab18; } /* call stem_suffix_chain_before_ki, line 354 */
+                {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 352 */
+                    if (ret == 0) { z->c = z->l - m11; goto lab18; }
                     if (ret < 0) return ret;
                 }
             lab18:
@@ -1423,10 +1340,9 @@ static int r_stem_suffix_chain_before_ki(struct SN_env * z) {
             }
             goto lab15;
         lab17:
-            z->c = z->l - m5;
-            {   int ret = r_stem_suffix_chain_before_ki(z);
-                if (ret == 0) return 0; /* call stem_suffix_chain_before_ki, line 356 */
-                if (ret < 0) return ret;
+            z->c = z->l - m10;
+            {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 354 */
+                if (ret <= 0) return ret;
             }
         }
     lab15:
